"\n"
"void RENDER\n"
"        (uint32_t *str, size_t L, \n"
"        int *RW, int *RH, int *RA,\n"
"        unsigned char **Rdata)\n"
"{\n"
"  static const uint8_t font_data[]= {\n"
"@FONTDATA\n"
"  };\n"
"  static const struct {\n"
"    uint32_t ds;\n"
"    uint16_t width;\n"
"  } glinfo[]= {\n"
"@GLMAP\n"
"  };\n"
"  // static const int nmap= sizeof(glmap)/sizeof(glmap[0]);\n"
"  int i,j,k,e,x,y,sX,eX;\n"
"  int W, X, *Xpos;\n"
"  char buf[20];\n"
"  int *map, *gl;\n"
"  int ngl;\n"
"  unsigned int C;\n"
"  int glyph_width;\n"
"  const unsigned char *glyph_data;\n"
"  unsigned char *data;\n"
"\n"
"  // the following two statements are required because\n"
"  // gcc warns about use of potentially uninitialized \n"
"  // variables. it\047s never the case, there are some flags\n"
"  // which are used to initialize them and then they\n"
"  // referred to only if the same flags are set. gcc\n"
"  // optimizer of course can\047t figure this out so I have\n"
"  // to put these here.\n"
"  Xpos= NULL;\n"
"  data= NULL;\n"
"\n"
"  map= alloca(L*sizeof(int));\n"
"\n"
"  e= 0;\n"
"  ngl= 0;\n"
"  for(i=0;i<L;i++)\n"
"  {\n"
"    C= str[i];\n"
"    \n"
"    if (C&(1<<31)) { ngl+=2; e= 1; continue; }\n"
"    map[i]= HASH(C);\n"
"    if (map[i]!=SENTINEL) { ngl++; continue; }\n"
"    sprintf(buf,\042%x\042,C); ngl+= strlen(buf); e= 1;\n"
"  }\n"
"\n"
"  if (e) goto fix_encoding_errors;\n"
"  else gl= map;\n"
"\n"
"encoding_errors_fixed:\n"
"\n"
"  W= 0;\n"
"  for(i=0;i<ngl;i++) W+= glinfo[gl[i]].width;\n"
"\n"
"  if (Rdata) data= malloc(W*FONT_HEIGHT);\n"
"  X= 0;\n"
"  if (e && Rdata) Xpos= alloca(sizeof(int)*(ngl+1));\n"
"  for(i=0;i<ngl;i++)\n"
"  {\n"
"    if (e && Rdata) Xpos[i]= X;\n"
"    glyph_width= glinfo[gl[i]].width;\n"
"    if (Rdata) {\n"
"      glyph_data= font_data + glinfo[gl[i]].ds;\n"
"      for(y=0;y<FONT_HEIGHT;y++)\n"
"         for(x=0;x<glyph_width;x++)\n"
"            data[y*W+X+x]= glyph_data[y*glyph_width+x];\n"
"    }\n"
"    X+= glyph_width;\n"
"  }\n"
"  if (e && Rdata) Xpos[i]= X;\n"
"  if (RW) *RW= W;\n"
"  if (RA) *RA= FONT_ASCENT;\n"
"  if (RH) *RH= FONT_HEIGHT;\n"
"  if (Rdata) *Rdata= data;\n"
"\n"
"  if (!e || !Rdata) return ;\n"
"\n"
"  j= 0;\n"
"  for(i=0;i<L;i++)\n"
"  {\n"
"    if (str[i]&(1<<31))\n"
"    {\n"
"      sX= Xpos[j]; eX= Xpos[j+2];\n"
"      for(x=sX;x<eX;x++)\n"
"        for(y=0;y<FONT_HEIGHT;y++)\n"
"          data[y*W + x] ^= 0xff;\n"
"      j+= 2;\n"
"      continue;\n"
"    }\n"
"    if (map[i]==SENTINEL)\n"
"    {\n"
"      sprintf(buf,\042%x\042,str[i]);\n"
"      sX= Xpos[j]; eX= Xpos[j+strlen(buf)];\n"
"      for(x=sX;x<eX;x++) {\n"
"        data[ 0*W + x]= 0xff;\n"
"        data[ (FONT_HEIGHT-1)*W + x]= 0xff;\n"
"      }\n"
"      for(y=0;y<FONT_HEIGHT;y++)\n"
"      {\n"
"        data[y*W+sX] = 0xff;\n"
"        data[y*W+eX-1] = 0xff;\n"
"      }\n"
"      j+= strlen(buf);\n"
"      continue;\n"
"    }\n"
"    j++;\n"
"  }\n"
"  return ;\n"
"\n"
"\n"
"fix_encoding_errors:\n"
"  j= 0;\n"
"  gl= alloca(sizeof(int)*ngl);\n"
"  for(i=0;i<L;i++)\n"
"  {\n"
"    if (str[i]&(1<<31))\n"
"    {\n"
"      sprintf(buf,\042%02x\042, str[i]&0xff);\n"
"      for(k=0;buf[k];k++)\n"
"         gl[j++]= HASH(buf[k]);\n"
"      continue;\n"
"    }\n"
"    if (map[i]==SENTINEL)\n"
"    {\n"
"      sprintf(buf,\042%x\042, str[i]);\n"
"      for(k=0;buf[k];k++)\n"
"         gl[j++]= HASH(buf[k]);\n"
"      continue;\n"
"    }\n"
"    gl[j++]= map[i];\n"
"  }\n"
"  goto encoding_errors_fixed;\n"
"}\n"

